1 # This shell scriplet is meant to be included by other shell scripts
2 # to set up some variables pointing at the normal git directories and
3 # a few helper shell functions.
5 # Having this variable in your environment would break scripts because
6 # you would cause "cd" to be taken to unexpected places. If you
7 # like CDPATH, define it for your interactive shell sessions without
9 # But we protect ourselves from such a user mistake nevertheless.
12 # Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
13 # do not equate an unset IFS with IFS with the default, so here is
14 # an explicit SP HT LF.
18 git_broken_path_fix () {
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
46 # Source git-sh-i18n for gettext support.
47 . "$(git --exec-path)/git-sh-i18n"
50 die_with_status 1 "$@"
56 printf >&2 '%s\n' "$*"
63 if test -z "$GIT_QUIET"
69 if test -n "$OPTIONS_SPEC"; then
76 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
77 parseopt_extra="--keep-dashdash"
78 [ -n "$OPTIONS_STUCKLONG" ] &&
79 parseopt_extra="$parseopt_extra --stuck-long"
82 echo "$OPTIONS_SPEC" |
83 git rev-parse --parseopt $parseopt_extra -- "$@" ||
87 dashless=$(basename -- "$0" | sed -e 's/-/ /')
89 die "$(eval_gettext "usage: \$dashless \$USAGE")"
92 if [ -z "$LONG_USAGE" ]
94 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE")"
96 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE
104 case "$0" in *git-legacy-stash) exit 129;; esac
109 # Set the name of the end-user facing command in the reflog when the
110 # script may update refs. When GIT_REFLOG_ACTION is already set, this
111 # will not overwrite it, so that a scripted Porcelain (e.g. "git
112 # rebase") can set it to its own name (e.g. "rebase") and then call
113 # another scripted Porcelain (e.g. "git am") and a call to this
114 # function in the latter will keep the name of the end-user facing
115 # program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
116 # does will be record as actions done as part of the end-user facing
117 # operation (e.g. "rebase").
119 # NOTE NOTE NOTE: consequently, after assigning a specific message to
120 # GIT_REFLOG_ACTION when calling a "git" command to record a custom
121 # reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
122 # after you are done. Other callers of "git" commands that rely on
123 # writing the default "program name" in reflog expect the variable to
124 # contain the value set by this function.
126 # To use a custom reflog message, do either one of these three:
128 # (a) use a single-shot export form:
129 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
130 # git command-that-updates-a-ref
132 # (b) save the original away and restore:
133 # SAVED_ACTION=$GIT_REFLOG_ACTION
134 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
135 # git command-that-updates-a-ref
136 # GIT_REFLOG_ACITON=$SAVED_ACTION
138 # (c) assign the variable in a subshell:
140 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
141 # git command-that-updates-a-ref
143 set_reflog_action() {
144 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
146 GIT_REFLOG_ACTION="$*"
147 export GIT_REFLOG_ACTION
152 if test -z "${GIT_EDITOR:+set}"
154 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
157 eval "$GIT_EDITOR" '"$@"'
163 GIT_PAGER=$(git var GIT_PAGER)
167 for vardef in @@PAGER_ENV@@
170 eval ": \"\${$vardef}\" && export $var"
173 eval "$GIT_PAGER" '"$@"'
177 GREP_OPTIONS= LC_ALL=C grep @@SANE_TEXT_GREP@@ "$@"
181 GREP_OPTIONS= LC_ALL=C egrep @@SANE_TEXT_GREP@@ "$@"
184 is_bare_repository () {
185 git rev-parse --is-bare-repository
189 cdup=$(git rev-parse --show-toplevel) &&
191 gettextln "Cannot chdir to \$cdup, the toplevel of the working tree" >&2
196 require_work_tree_exists () {
197 if test "z$(git rev-parse --is-bare-repository)" != zfalse
200 die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")"
204 require_work_tree () {
205 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true || {
207 die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")"
211 require_clean_work_tree () {
212 git rev-parse --verify HEAD >/dev/null || exit 1
213 git update-index -q --ignore-submodules --refresh
216 if ! git diff-files --quiet --ignore-submodules
221 gettextln "Cannot rebase: You have unstaged changes." >&2
224 gettextln "Cannot rewrite branches: You have unstaged changes." >&2
227 gettextln "Cannot pull with rebase: You have unstaged changes." >&2
230 eval_gettextln "Cannot \$action: You have unstaged changes." >&2
236 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
243 gettextln "Cannot rebase: Your index contains uncommitted changes." >&2
246 gettextln "Cannot pull with rebase: Your index contains uncommitted changes." >&2
249 eval_gettextln "Cannot \$action: Your index contains uncommitted changes." >&2
253 gettextln "Additionally, your index contains uncommitted changes." >&2
260 test -n "$2" && echo "$2" >&2
265 # Generate a sed script to parse identities from a commit.
267 # Reads the commit from stdin, which should be in raw format (e.g., from
268 # cat-file or "--pretty=raw").
270 # The first argument specifies the ident line to parse (e.g., "author"), and
271 # the second specifies the environment variable to put it in (e.g., "AUTHOR"
272 # for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
274 pick_ident_script () {
283 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
284 s/.*/GIT_${uid}_NAME='&'/p
287 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
288 s/.*/GIT_${uid}_EMAIL='&'/p
291 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
292 s/.*/GIT_${uid}_DATE='&'/p
299 # Create a pick-script as above and feed it to sed. Stdout is suitable for
301 parse_ident_from_commit () {
302 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
305 # Parse the author from a commit given as an argument. Stdout is suitable for
306 # feeding to eval to set the usual GIT_* ident variables.
307 get_author_ident_from_commit () {
308 encoding=$(git config i18n.commitencoding || echo UTF-8)
309 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
310 parse_ident_from_commit author AUTHOR
313 # Clear repo-local GIT_* environment variables. Useful when switching to
314 # another repository (e.g. when entering a submodule). See also the env
315 # list in git_connect()
316 clear_local_git_env() {
317 unset $(git rev-parse --local-env-vars)
320 # Generate a virtual base file for a two-file merge. Uses git apply to
321 # remove lines from $1 that are not in $2, leaving only common lines.
322 create_virtual_base() {
324 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
327 # If we do not have enough common material, it is not
328 # worth trying two-file merge using common subsections.
329 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
333 # Platform specific tweaks to work around some commands
336 # Windows has its own (incompatible) sort and find
343 # git sees Windows-style pwd
347 is_absolute_path () {
356 is_absolute_path () {
365 # Make sure we are in a valid repository of a vintage we understand,
366 # if we require to be in a git repository.
368 GIT_DIR=$(git rev-parse --git-dir) || exit
369 if [ -z "$SUBDIRECTORY_OK" ]
371 test -z "$(git rev-parse --show-cdup)" || {
373 gettextln "You need to run this command from the toplevel of the working tree." >&2
377 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
378 gettextln "Unable to determine absolute path of git directory" >&2
381 : "${GIT_OBJECT_DIRECTORY="$(git rev-parse --git-path objects)"}"
384 if test -z "$NONGIT_OK"
392 peeltmp=$(git rev-parse --verify "$1") &&
393 git rev-parse --verify "${peeltmp}^0"
396 git rev-parse --verify "${1}^0"